/********************************************************************
 *
 *	Display.java
 *		Collect the data from ThreatDectection
 *		and FireControl, and send the data to
 *		the civ servlet through the  socket.
 *		In socket connection, the servlet is
 *		a server and Display.java is a client.
 *
 *	Type : application
 *
 *	Author : Dongmin Kim
 *  
 *	Modifying History:
 *		June/9/98 by Dongmin Kim
 *
 ********************************************************************/

import java.net.URL;
import java.sql.*;
import java.util.*;
import java.awt.*;
import java.lang.*;
import java.net.*;
import java.io.*;

class Display {

	// socket variables
	private static String server_IP = "128.230.61.75";
	private static Socket sd = null;
	private static int	port = 16005;
	private static PrintStream	out_data = null;

	// define variables for JavaDVM by I. Ra 05/02/98
	private static int   targc;      // no. of arguments for the task
	// argument list for the task
	private static String targs[] = new String[20];
	private static String mytaskname; // my task name
 
	private static int   mytaskid;   // my task id
	private static int   first_input_port; // 1st input port
	private static int   second_input_port; // 2nd input port
	private static int   first_output_port; // 1st output port

	private static PrintStream ff1 = null;

	private static String out_file;

       /*********************************************************
	*
	*	Display() :
	*		constructor of Display class
	*
	*********************************************************/
	public Display(String argv[]) {
		int	i, j, k;
		int	vdceresult;
		Integer	inport1, inport2, outport;

		ff1.println("vdcemain called : " + 
				argv[0] + " " + argv[1] + " " + argv[2] + " " + 
				argv[3] + " " + argv[4] + " " + argv[5] + " " + 
				argv[6] + " " +	argv[7] + " " + argv[8] + " " + 
				argv[9]);

		vdceresult = JavaDVM.vdcemain(argv, targs);

		ff1.println("After vdecmain");
		ff1.flush();
		// starts DVM initinialization
 
		if (vdceresult != 0) {
			ff1.println("Java DVM init has been done.");
			//inport1 = Integer.valueOf(targs[1]);
			//first_input_port = inport1.intValue();
			first_input_port = 1;
			//inport2 = Integer.valueOf(targs[2]);
			//second_input_port = inport2.intValue();
			second_input_port = 2;
//			outport = Integer.valueOf(targs[3]);
//			first_output_port = outport.intValue();
			ff1.println("inport1= "+first_input_port+" inport2= "+second_input_port);
			mytaskname = JavaDVM.vdcegetmyname();   // get task name
			ff1.println("done get mytaskname");
			mytaskid = JavaDVM.vdcegetmyid();       // get task id
		        ff1.println("done get mytaskid");
			ff1.println("Display Starts " + mytaskname);
		}
		else {
			System.out.println("Java DVM has not been successed due to error");
		}
	}

       /*********************************************************
	*
	*	set_socket_Connection() :
	*		set the socket connection
	*
	*********************************************************/
	public static void set_socket_Connection() {

		boolean connected = false;

		int counter = 0;

		while(!connected) {
			try {
				sd = new Socket(server_IP, port);
				connected = true;
			}
			catch (IOException ioe) {
				connected = false;
				counter++;
				//ff1.println("Trial " + counter + " try to connect to the server");
			}
		}

		ff1.println("connected to the server!!");

		try {
			out_data = new PrintStream(sd.getOutputStream());
		}  
		catch(IOException e) {
			ff1.println("Exception while getting socket Stream: " + e);
			System.exit(1);
		}
	}

       /*********************************************************
	*
	*	close_socket_Connection() :
	*		close  databse connection
	*
	*********************************************************/
	public static void close_socket_Connection() {

		out_data.close();

		try {
			sd.close();
		}
		catch (Exception e) {
			ff1.println(e);
		}

		ff1.println("close the socket");
		ff1.flush();
	}
       /*********************************************************
	*
	*	report_end() :
	*		report the end to the local ACS
	*
	*********************************************************/
	public static void report_end() {

		ff1.println("report before end");
		ff1.flush();

		// report end to the local ACS
		JavaDVM.vdceend(0);

		ff1.println("report end");
		ff1.flush();

	}

       /*********************************************************
	*
	*	recv_send() :
	*		receive the data from ThreatDection and	FireControl,
	*		merge them and
	*		send it to the civ servlet.
	*
	*********************************************************/
	public static void recv_send() {

		/* vdce_recv from ThreadDectection the initial values */
		String init_value = JavaDVM.vdcerecv(first_input_port);
		if ( init_value == null ) {
			try {
//				ff1.println("JavaDVM.vdcerecv() has no data");
			}
			catch(Exception e)
			{
				System.exit(1);
			}
		}

		// send the initial value to the servlet
		out_data.println(init_value);
		out_data.flush();

		int	frame = 0;
		boolean	loop = true;

		current_date	cur_date = new current_date();
		int	exe_counter = 10;
		long	elapsed_start = cur_date.milliseconds();

		while ( loop ) {

			String	frame_data = null;
			frame++;
			ff1.println("==============================");
			ff1.println("Frame : " + frame);

			String	recvbuf1 = null;  // return storage to the garbage collector
			String	recvbuf2 = null;  // return storage to the garbage collector

			/* vdce_recv from ThreadDectection */

			ff1.println("-----------------------------");
			ff1.println("1: " +
				cur_date.hours() + " : " +
				cur_date.minutes() + " : " +
				cur_date.seconds() + "      " +
				cur_date.milliseconds() );

			recvbuf1 = JavaDVM.vdcerecv(first_input_port);

			ff1.println("2: " +
				cur_date.hours() + " : " +
				cur_date.minutes() + " : " +
				cur_date.seconds() + "      " +
				cur_date.milliseconds() );

//			ff1.println("Display got data from ThreatDetection");

//			ff1.println("---------------------------------------");
//			ff1.println("data from ThreatDetection" + recvbuf1);
//			ff1.println("---------------------------------------");

			/* vdce_recv from FireControl */

			recvbuf2 = JavaDVM.vdcerecv(second_input_port);

			ff1.println("3: " +
				cur_date.hours() + " : " +
				cur_date.minutes() + " : " +
				cur_date.seconds() + "      " +
				cur_date.milliseconds() );

			// ff1.println("Display got data from Firecontrol");
			// ff1.println("---------------------------------------");
			// ff1.println("data from FireControl" + recvbuf2);
			// ff1.println("---------------------------------------");

			if ( recvbuf1 == null || recvbuf2 == null ) {
				ff1.print("JavaDVM.vdcerecv() has no data");
				if ( recvbuf1 == null ) {
					ff1.print("  on buf1");
				}
				if ( recvbuf2 == null ) {
					ff1.print("  on buf2");
				}
				ff1.println("");
				loop = false;
				frame_data = null;
			}
			else {
				frame_data = frame + " " + recvbuf1 + " " + recvbuf2;
			}

			// send the frame data to the servlet through the socket
			out_data.println(frame_data);
			out_data.flush();

			long	elapsed_end = cur_date.milliseconds();

			long	elapsed_time = elapsed_end - elapsed_start;

			if ( exe_counter == 10 ) {
//				JavaDVM.vdcereportexecutiontime(2, elapsed_time);
				exe_counter = 0;
			}
			exe_counter++;

			ff1.println("4: " +
				cur_date.hours() + " : " +
				cur_date.minutes() + " : " +
				cur_date.seconds() + "      " +
				cur_date.milliseconds() );

		} // end of while

		ff1.println("end of data");
		long	elapsed_end = cur_date.milliseconds();
		long	elapsed_time = elapsed_end - elapsed_start;
		JavaDVM.vdcereportexecutiontime(2, elapsed_time);
	}

       /*********************************************************
	*
	*	main() :
	*		main of Display class
	*
	*********************************************************/
	public static void main(String argv[]) {

		out_file = "/tmp/Display";
		try {
			FileOutputStream f_out = new FileOutputStream(out_file);
			ff1 = new PrintStream(f_out);

			ff1.println("Display start!");
		}
		catch(IOException e)
		{
			System.exit(1);
		}

		ff1.println("Display started");

		Display	display_civ = new Display(argv);

		ff1.close();  // close old one
		out_file = "/tmp/Display" + "_" + mytaskid;
		try {
			FileOutputStream f_out = new FileOutputStream(out_file);
			ff1 = new PrintStream(f_out);

			ff1.println("Display start!");
		}
		catch(IOException e)
		{
			System.exit(1);
		}

		// make a socket connection to the civ servlet
		display_civ.set_socket_Connection();

		// receive the data from ThreatDetection and FireControl
		display_civ.recv_send();

		// close the socket connection
		display_civ.close_socket_Connection();

//		display_civ.report_end();

		ff1.println("new report before end");
		ff1.flush();

		// report end to the local ACS
		JavaDVM.vdceend(0);

		ff1.println("new report end");
		ff1.flush();


		ff1.close();
	}
}
